﻿using Syncfusion.JavaScript.DataVisualization.Maps;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Script.Serialization;

namespace MapGridSample.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {

            ViewData["mapdata"] = this.GetWroldMap();
            ViewData["griddata"] = Country_LatLongPoints.GetCountryLatLongPoints();
            return View();
        }

        public object GetWroldMap()
        {
            string allText = System.IO.File.ReadAllText(Server.MapPath("~/App_Data/WorldMap.json"));
            JavaScriptSerializer ser = new JavaScriptSerializer();
            ser.MaxJsonLength = int.MaxValue;
            return new MapData(allText);
        }

        public ActionResult About()
        {
            ViewBag.Message = "Your app description page.";

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }
    }

    public class Country_LatLongPoints
    {
        public static List<LatLongPoints> GetCountryLatLongPoints()
        {
            List<LatLongPoints> countryLatLongPoints = new List<LatLongPoints>
            {
                new LatLongPoints {Name =  "Afghanistan", Latitude = 33, Longitude = 65 },
               new LatLongPoints {Name =  "Angola", Latitude = -12.5, Longitude = 18.5 },
                 new LatLongPoints {Name =  "Argentina", Latitude = -34, Longitude = -64 },
                new LatLongPoints {Name =  "Bangladesh", Latitude = 24, Longitude = 90 },
                new LatLongPoints {Name =  "Belarus", Latitude = 53, Longitude = 28 },
                new LatLongPoints {Name =  "Belgium", Latitude = 50.8333, Longitude = 4 },
                new LatLongPoints {Name =  "Botswana", Latitude = -22, Longitude = 24 },
                new LatLongPoints {Name =  "Brazil", Latitude = -10, Longitude = -55 },
               new LatLongPoints {Name =  "Burundi", Latitude = -3.5, Longitude = 30 },
                 new LatLongPoints {Name =  "Canada", Latitude = 60, Longitude = -95 },
                 new LatLongPoints {Name =  "Chad", Latitude = 15, Longitude = 19 },
                new LatLongPoints {Name =  "Chile", Latitude = -30, Longitude = -71 },
                new LatLongPoints {Name =  "China", Latitude = 35, Longitude = 105 },
                new LatLongPoints {Name =  "Christmas Island", Latitude = -10.5, Longitude = 105.6667 },
                new LatLongPoints {Name =  "Cocos (Keeling) Islands", Latitude = -12.5, Longitude = 96.8333 },
                new LatLongPoints {Name =  "Colombia", Latitude = 4, Longitude = -72 },
                new LatLongPoints {Name =  "Comoros", Latitude = -12.1667, Longitude = 44.25 },
                new LatLongPoints {Name =  "Congo", Latitude = -1, Longitude = 15 },
                new LatLongPoints {Name =  "Cook Islands", Latitude = -21.2333, Longitude = -159.7667 },
                new LatLongPoints {Name =  "Costa Rica", Latitude = 10, Longitude = -84 },
                new LatLongPoints {Name =  "Cote D'Ivoire (Ivory Coast)", Latitude = 8, Longitude = -5 },
                new LatLongPoints {Name =  "Croatia (Hrvatska)", Latitude = 45.1667, Longitude = 15.5 },
                new LatLongPoints {Name =  "Cuba", Latitude = 21.5, Longitude = -80 },
                new LatLongPoints {Name =  "Cyprus", Latitude = 35, Longitude = 33 },
                new LatLongPoints {Name =  "Czech Republic", Latitude = 49.75, Longitude = 15.5 },
                new LatLongPoints {Name =  "Denmark", Latitude = 56, Longitude = 10 },
                new LatLongPoints {Name =  "Djibouti", Latitude = 11.5, Longitude = 43 },
                new LatLongPoints {Name =  "Dominica", Latitude = 15.4167, Longitude = -61.3333 },
                new LatLongPoints {Name =  "Dominican Republic", Latitude = 19, Longitude = -70.6667 },
                new LatLongPoints {Name =  "East Timor", Latitude = 0, Longitude = 0 },
                new LatLongPoints {Name =  "Faroe Islands", Latitude = 62, Longitude = -7 },
                new LatLongPoints {Name =  "Fiji", Latitude = -18, Longitude = 175 },
                new LatLongPoints {Name =  "Finland", Latitude = 64, Longitude = 26 },
                new LatLongPoints {Name =  "France", Latitude = 46, Longitude = 2 },
                new LatLongPoints {Name =  "French Guiana", Latitude = 4, Longitude = -53 },
                new LatLongPoints {Name =  "French Polynesia", Latitude = -15, Longitude = -140 },
                new LatLongPoints {Name =  "French Southern Territories", Latitude = -43, Longitude = 67 },
                new LatLongPoints {Name =  "Gabon", Latitude = -1, Longitude = 11.75 },
                new LatLongPoints {Name =  "Gambia", Latitude = 13.4667, Longitude = -16.5667 },
                new LatLongPoints {Name =  "Georgia", Latitude = 42, Longitude = 43.5 },
                new LatLongPoints {Name =  "Germany", Latitude = 51, Longitude = 9 },
                new LatLongPoints {Name =  "Ghana", Latitude = 8, Longitude = -2 },
                new LatLongPoints {Name =  "Greece", Latitude = 39, Longitude = 22 },
                new LatLongPoints {Name =  "Greenland", Latitude = 72, Longitude = -40 },
                new LatLongPoints {Name =  "Grenada", Latitude = 12.1167, Longitude = -61.6667 },
                new LatLongPoints {Name =  "Guadeloupe", Latitude = 16.25, Longitude = -61.5833 },
                new LatLongPoints {Name =  "Guam", Latitude = 13.4667, Longitude = 144.7833 },
                new LatLongPoints {Name =  "Guatemala", Latitude = 15.5, Longitude = -90.25 },
                new LatLongPoints {Name =  "Guinea", Latitude = 11, Longitude = -10 },
                new LatLongPoints {Name =  "Guinea-Bissau", Latitude = 12, Longitude = -15 },
                new LatLongPoints {Name =  "Guyana", Latitude = 5, Longitude = -59 },
                new LatLongPoints {Name =  "Haiti", Latitude = 19, Longitude = -72.4167 },
               new LatLongPoints {Name =  "India", Latitude = 20, Longitude = 77 },
                new LatLongPoints {Name =  "Indonesia", Latitude = -5, Longitude = 120 },
                new LatLongPoints {Name =  "Iran", Latitude = 32, Longitude = 53 },
                new LatLongPoints {Name =  "Iraq", Latitude = 33, Longitude = 44 },
                new LatLongPoints {Name =  "Ireland", Latitude = 53, Longitude = -8 },
                new LatLongPoints {Name =  "Israel", Latitude = 31.5, Longitude = 34.75 },
                new LatLongPoints {Name =  "Italy", Latitude = 42.8333, Longitude = 12.8333 },
                new LatLongPoints {Name =  "Jamaica", Latitude = 18.25, Longitude = -77.5 },
                new LatLongPoints {Name =  "Japan", Latitude = 36, Longitude = 138 },
                new LatLongPoints {Name =  "Jordan", Latitude = 31, Longitude = 36 },
                new LatLongPoints {Name =  "Kazakhstan", Latitude = 48, Longitude = 68 },
                new LatLongPoints {Name =  "Kenya", Latitude = 1, Longitude = 38 },
                new LatLongPoints {Name =  "Kiribati", Latitude = 1.4167, Longitude = 173 },
                new LatLongPoints {Name =  "Korea (North)", Latitude = 40, Longitude = 127 },
                new LatLongPoints {Name =  "Korea (South)", Latitude = 37, Longitude = 127.5 },
                new LatLongPoints {Name =  "Kuwait", Latitude = 29.3375, Longitude = 47.6581 },
                new LatLongPoints {Name =  "Kyrgyzstan", Latitude = 41, Longitude = 75 },
                new LatLongPoints {Name =  "Laos", Latitude = 18, Longitude = 105 },
                new LatLongPoints {Name =  "Latvia", Latitude = 57, Longitude = 25 },
                new LatLongPoints {Name =  "Macau", Latitude = 22.1667, Longitude = 113.55 },
                new LatLongPoints {Name =  "Macedonia", Latitude = 41.8333, Longitude = 22 },
                new LatLongPoints {Name =  "Madagascar", Latitude = -20, Longitude = 47 },
                new LatLongPoints {Name =  "Malawi", Latitude = -13.5, Longitude = 34 },
                new LatLongPoints {Name =  "Malaysia", Latitude = 2.5, Longitude = 112.5 },
                new LatLongPoints {Name =  "Maldives", Latitude = 3.25, Longitude = 73 },
                new LatLongPoints {Name =  "Mali", Latitude = 17, Longitude = -4 },
                new LatLongPoints {Name =  "Malta", Latitude = 35.8333, Longitude = 14.5833 },
                new LatLongPoints {Name =  "Marshal Islands", Latitude = 9, Longitude = 168 },
                new LatLongPoints {Name =  "Martinique", Latitude = 14.6667, Longitude = -61 },
                new LatLongPoints {Name =  "Mauritania", Latitude = 20, Longitude = -12 },
                new LatLongPoints {Name =  "Mauritius", Latitude = -20.2833, Longitude = 57.55 },
                new LatLongPoints {Name =  "Mayotte", Latitude = -12.8333, Longitude = 45.1667 },
                new LatLongPoints {Name =  "Mexico", Latitude = 23, Longitude = -102 },
                new LatLongPoints {Name =  "Micronesia", Latitude = 6.9167, Longitude = 158.25 },
                new LatLongPoints {Name =  "Moldova", Latitude = 47, Longitude = 29 },
                new LatLongPoints {Name =  "Monaco", Latitude = 43.7333, Longitude = 7.4 },
                new LatLongPoints {Name =  "Mongolia", Latitude = 46, Longitude = 105 },
                new LatLongPoints {Name =  "Montserrat", Latitude = 16.75, Longitude = -62.2 },
                new LatLongPoints {Name =  "Morocco", Latitude = 32, Longitude = -5 },
                new LatLongPoints {Name =  "Mozambique", Latitude = -18.25, Longitude = 35 },
                new LatLongPoints {Name =  "Myanmar", Latitude = 22, Longitude = 98 },
                new LatLongPoints {Name =  "Namibia", Latitude = -22, Longitude = 17 },
                new LatLongPoints {Name =  "Nauru", Latitude = -0.5333, Longitude = 166.9167 },
                new LatLongPoints {Name =  "Nepal", Latitude = 28, Longitude = 84 },
                new LatLongPoints {Name =  "Netherland Antilles", Latitude = 12.25, Longitude = -68.75 },
                new LatLongPoints {Name =  "Netherlands", Latitude = 52.5, Longitude = 5.75 },
                new LatLongPoints {Name =  "New Caledonia", Latitude = -21.5, Longitude = 165.5 },
                new LatLongPoints {Name =  "New Zealand", Latitude = -41, Longitude = 174 },
                new LatLongPoints {Name =  "Nicaragua", Latitude = 13, Longitude = -85 },
                new LatLongPoints {Name =  "Niger", Latitude = 16, Longitude = 8 },
                new LatLongPoints {Name =  "Nigeria", Latitude = 10, Longitude = 8 },
                new LatLongPoints {Name =  "Niue", Latitude = -19.0333, Longitude = -169.8667 },
                new LatLongPoints {Name =  "Norfolk Island", Latitude = -29.0333, Longitude = 167.95 },
                new LatLongPoints {Name =  "Northern Marianas Islands", Latitude = 15.2, Longitude = 145.75 },
                new LatLongPoints {Name =  "Norway", Latitude = 62, Longitude = 10 },
                new LatLongPoints {Name =  "Oman", Latitude = 21, Longitude = 57 },
                new LatLongPoints {Name =  "other", Latitude = 0, Longitude = 0 },
                new LatLongPoints {Name =  "Pakistan", Latitude = 30, Longitude = 70 },
                new LatLongPoints {Name =  "Palau", Latitude = 7.5, Longitude = 134.5 },
                new LatLongPoints {Name =  "Panama", Latitude = 9, Longitude = -80 },
                new LatLongPoints {Name =  "Papua New Guinea", Latitude = -6, Longitude = 147 },
                new LatLongPoints {Name =  "Paraguay", Latitude = -23, Longitude = -58 },
                new LatLongPoints {Name =  "Peru", Latitude = -10, Longitude = -76 },
                new LatLongPoints {Name =  "Philippines", Latitude = 13, Longitude = 122 },
                new LatLongPoints {Name =  "Pitcairn", Latitude = 0, Longitude = 0 },
                new LatLongPoints {Name =  "Poland", Latitude = 52, Longitude = 20 },
                new LatLongPoints {Name =  "Portugal", Latitude = 39.5, Longitude = -8 },
                new LatLongPoints {Name =  "Puerto Rico", Latitude = 18.25, Longitude = -66.5 },
                new LatLongPoints {Name =  "Qatar", Latitude = 25.5, Longitude = 51.25 },
                new LatLongPoints {Name =  "Reunion", Latitude = -21.1, Longitude = 55.6 },
                new LatLongPoints {Name =  "Romania", Latitude = 46, Longitude = 25 },
                new LatLongPoints {Name =  "Russian Federation", Latitude = 60, Longitude = 100 },
                new LatLongPoints {Name =  "Rwanda", Latitude = -2, Longitude = 30 },
               new LatLongPoints {Name =  "Saudi Arabia", Latitude = 25, Longitude = 45 },
                new LatLongPoints {Name =  "Senegal", Latitude = 14, Longitude = -14 },
                new LatLongPoints {Name =  "Seychelles", Latitude = -4.5833, Longitude = 55.6667 },
                new LatLongPoints {Name =  "Sierra Leone", Latitude = 8.5, Longitude = -11.5 },
                new LatLongPoints {Name =  "Singapore", Latitude = 1.3667, Longitude = 103.8 },
                new LatLongPoints {Name =  "Slovak Republic", Latitude = 48.6667, Longitude = 19.5 },
                new LatLongPoints {Name =  "Slovenia", Latitude = 46, Longitude = 15 },
                new LatLongPoints {Name =  "Solomon Islands", Latitude = -8, Longitude = 159 },
                new LatLongPoints {Name =  "Somalia", Latitude = 10, Longitude = 49 },
                new LatLongPoints {Name =  "South Africa", Latitude = -29, Longitude = 24 },
                new LatLongPoints {Name =  "South Georgia and the South Sandwich Islands", Latitude = -54.5, Longitude = -37 },
                new LatLongPoints {Name =  "Spain", Latitude = 40, Longitude = -4 },
                new LatLongPoints {Name =  "Sri Lanka", Latitude = 7, Longitude = 81 },
                new LatLongPoints {Name =  "Sudan", Latitude = 15, Longitude = 30 },
                new LatLongPoints {Name =  "Suriname", Latitude = 4, Longitude = -56 },
                new LatLongPoints {Name =  "Svalbard and Jan Mayen Islands", Latitude = 78, Longitude = 20 },
                new LatLongPoints {Name =  "Swaziland", Latitude = -26.5, Longitude = 31.5 },
                new LatLongPoints {Name =  "Sweden", Latitude = 62, Longitude = 15 },
                new LatLongPoints {Name =  "Switzerland", Latitude = 47, Longitude = 8 },
                new LatLongPoints {Name =  "Syria", Latitude = 35, Longitude = 38 },
                new LatLongPoints {Name =  "Taiwan", Latitude = 23.5, Longitude = 121 },
                new LatLongPoints {Name =  "Tajikistan", Latitude = 39, Longitude = 71 },
                new LatLongPoints {Name =  "Tanzania", Latitude = -6, Longitude = 35 },
                new LatLongPoints {Name =  "Thailand", Latitude = 15, Longitude = 100 },
                new LatLongPoints {Name =  "Togo", Latitude = 8, Longitude = 1.1667 },
                new LatLongPoints {Name =  "Tokelau", Latitude = -9, Longitude = -172 },
                new LatLongPoints {Name =  "Tonga", Latitude = -20, Longitude = -175 },
                new LatLongPoints {Name =  "Trinidad and Tobago", Latitude = 11, Longitude = -61 },
                new LatLongPoints {Name =  "Tunisia", Latitude = 34, Longitude = 9 },
                new LatLongPoints {Name =  "Turkey", Latitude = 39, Longitude = 35 },
                new LatLongPoints {Name =  "Turkmenistan", Latitude = 40, Longitude = 60 },
                new LatLongPoints {Name =  "Turks and Caicos Islands", Latitude = 21.75, Longitude = -71.5833 },
                new LatLongPoints {Name =  "Tuvalu", Latitude = -8, Longitude = 178 },
                new LatLongPoints {Name =  "Uganda", Latitude = 1, Longitude = 32 },
                new LatLongPoints {Name =  "Ukraine", Latitude = 49, Longitude = 32 },
                new LatLongPoints {Name =  "United Arab Emirates", Latitude = 24, Longitude = 54 },
                new LatLongPoints {Name =  "United Kingdom", Latitude = 54, Longitude = -2 },
                new LatLongPoints {Name =  "United States of America", Latitude = 38, Longitude = -97 },
                new LatLongPoints {Name =  "Uruguay", Latitude = -33, Longitude = -56 },
                new LatLongPoints {Name =  "Uzbekistan", Latitude = 41, Longitude = 64 },
                new LatLongPoints {Name =  "Vanuatu", Latitude = -16, Longitude = 167 },
                new LatLongPoints {Name =  "Vatican City", Latitude = 41.9, Longitude = 12.45 },
                new LatLongPoints {Name =  "Venezuela", Latitude = 8, Longitude = -66 },
                new LatLongPoints {Name =  "Vietnam", Latitude = 16, Longitude = 106 },
                new LatLongPoints {Name =  "Virgin Islands (British)", Latitude = 18.3333, Longitude = -64.8333 },
                new LatLongPoints {Name =  "Virgin Islands (US)", Latitude = 0, Longitude = 0 },
                new LatLongPoints {Name =  "Wallis and Futuna Islands", Latitude = -13.3, Longitude = -176.2 },
                new LatLongPoints {Name =  "Western Sahara", Latitude = 24.5, Longitude = -13 },
                new LatLongPoints {Name =  "Yemen", Latitude = 15, Longitude = 48 },
                new LatLongPoints {Name =  "Yugoslavia", Latitude = 0, Longitude = 0 },
                new LatLongPoints {Name =  "Zaire", Latitude = -20, Longitude = 30 },
                new LatLongPoints {Name =  "Zambia", Latitude = -15, Longitude = 30 },
                new LatLongPoints {Name =  "Zimbabwe", Latitude = 0, Longitude = 0 }
            };
            return countryLatLongPoints;
        }
    }

    public class LatLongPoints
    {
        private string name;
        public string Name
        {
            get { return name; }
            set { name = value; }
        }

        public double latitude;

        public double Latitude
        {
            get { return latitude; }
            set { latitude = value; }
        }

        public double longitude;

        public double Longitude
        {
            get { return longitude; }
            set { longitude = value; }
        }

    }
}
